# generated by datamodel-codegen:
#   filename:  xarm_utokyo_ds
#   timestamp: 2024-06-27T22:43:30+00:00

from __future__ import annotations

import numpy as np

from embdata.episode import ImageTask, VisionMotorStep
from embdata.geometry import Pose
from embdata.image import Image
from embdata.motion import AbsoluteMotionField
from embdata.motion.control import AbsoluteHandControl, RelativePoseHandControl
from embdata.ndarray import NumpyArray
from embdata.sample import Sample
from embdata.geometry import CoordinateField


class State(Sample):
    end_effector_pose: Pose = AbsoluteMotionField(
        default_factory=Pose, description="Absolute End Effector pose of the robot."
    )
    hand_image: Image
    image2: Image
    joint_state: NumpyArray = AbsoluteMotionField(
        default_factory=lambda: np.zeros((7,)),
        description="Joint state of the robot.",
        shape=(7,),
    )
    discount: float
    is_first: int
    is_last: int
    is_terminal: int
    joint_trajectory: NumpyArray
    language_embedding: NumpyArray


class Step(VisionMotorStep):
    episode_idx: int
    step_idx: int
    image: Image
    action: RelativePoseHandControl
    absolute_action: AbsoluteHandControl
    state: State
    supervision: float
    timestamp: float = CoordinateField(default=0.0, description="Timestamp of the step in seconds.", unit="s")


class Observation(ImageTask):
    pass
